# Clinica Chimica Acta Ref2RIS Converter v. 1.3
# Copyright (C) 2011 Deborah Fitchett
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
########################################################################

# For best results, prepare input according to the ReadMe instructions.

# Tidy up tags, punctuation, spurious spacing, blank lines, and urls
s/\<[^/>]*\>$//
s/^\<\/[^>]*\>//
s/\(\<[^/>]*\>\)\([^0-9A-Za-z<>]*\)/\2\1/g
s/\([^0-9A-Za-z<>]*\)\(\<\/[^>]*\>\)/\2\1/g
s/\<\([^/>]*\)\>\([^a-zA-Z0-9<>]*\)\<\/\1\>/\2/g
s/\<\/\([^>]*\)\>\([^a-zA-Z0-9<>]*\)\<\1\>/\2/g
s/ *- */-/g
s/\( \)\([ ,]*\)/\1/g
s/^[ 	]*//
s/[ 	]*$//
s/[ 	][ 	]*/ /g
/^$/d
s/\([^/]\)www/\1http:\/\/www/g

# Deliminate records (adding a copy of the full record to the notes field)
s/[., 	]*$//
s/\(.*\)$/\1@@N1  - \1@@ER  - /

# Strip numbers from the start
s/^[[0-9]*][ 	]*//

# Deal with the format Author. Title1.
s/^\([^@.]*\)\. \([^@.?]*\?*\)\.* */@@A1  - \1@@T1  - \2@@T2  - /

# Deal with Journal Year;vol:sp-ep. format
s/@@T2  - \([^@;0-9]*\)\([0-9]*;\)/@@JF  - \1@@Y1  - \2/
s/\(@@Y1  - [^@;]*\); *\([^@:]*:\)/\1@@VL  - \2/
s/\(@@Y1  - [^@;]*\); *\([0-9]* *-\)/\1@@SP  - \2/
s/\(@@VL  - [^@:]*\): *\([0-9]* *-*\)/\1@@SP  - \2/
s/\(@@SP  - [^@-]*\) *- *\([0-9]*\)/\1@@EP  - \2/

# Deal with in: I. M. Editor (Ed), Title2
s/@@T2  - in:* \([^@()]*\) (Eds*\.*), /@@A2  - \1@@T2  - /

# Deal with Title. City: Publisher, Year: sp-ep. format
s/\(@@T[12]  - [^@.]*\)\. /\1@@CY  - /
s/\(@@CY  - [^@:]*\): */\1@@PB  - /
s/\(@@PB  - [^@0-9]*\), */\1@@Y1  - /
s/\(@@Y1  - [^@:]*\): */\1@@SP  - /

# Deal with editions
s/\(@@T[12]  - [^@]*\), \([0-9a-z]*\) ed@@/\1@@VL  - \1@@/

# Keep italicised species names etc in T1
: sp_loop
s/\<i\>\([^<]*\)\<\/i\>\(.*@@T2\)/\<species\>\1\<\/species\>\2/
s/\<i\>\([^<]*\)\<\/i\>\(.*@@JF\)/\<species\>\1\<\/species\>\2/
t sp_loop

# Get rid of unnecessary html tags (bold, italics, underline)
s/\<\/*b\>//g
s/\<\/*i\>//g
s/\<\/*u\>//g
s/species\>/i\>/g

# Classify records
/@@JF/s/^/@@TY  - JOUR/
/@@TY/!s/^\(.* [Tt]hesis\)/@@TY  - THES\1/
/@@TY/!s/^\(.* [Dd]issertation\)/@@TY  - THES\1/
/@@TY/!s/^\(.* [Cc]onference\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Cc]ongress\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Ww]orkshop\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Ss]eminar\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Rr]eport\)/@@TY  - RPRT\1/
/@@TY/!s/^\(.*@@T2\)/@@TY  - CHAP\1/
/@@TY/!s/^/@@TY  - BOOK/

# Appropriately split information in the author field
s/\(@@[^@]*\), et al\([^@]*@@[^E]\)/\1\2/g
: au_loop
s/\(@@A[12]  - \)\([^@,]*\), /\1\2\1/g
t au_loop
s/\(@A[12]  - [^@]*\) \([A-Z]*@\)/\1, \2/g

# Standardise field names
s/@@A1/@@AU/g
s/@@T1/@@TI/
s/@@Y1/@@PY/

# Finally replace placeholder with linebreak.
s/@@/\
/g