# Mystery Style #01 Ref2RIS Converter v. 1.0
# Copyright (C) 2011 Deborah Fitchett
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
########################################################################

# Get rid of unnecessary html tags (bold, italics, underline)
s/\<\/*b\>//g
s/\<\/*i\>//g
s/\<\/*u\>//g

# Tidy up tags, punctuation, spurious spacing, blank lines, and urls
s/\( \)*\([ ,.]\)/\2/g
s/[ 	][ 	]*/ /g
s/^[ ]*//
s/[ ]*$//
/^$/d
s/\([^/]\)www/\1http:\/\/www/g

# Deliminate records (adding a copy of the full record to the notes field)
s/\(.*\)$/@@A1  - \1@@N1  - \1@@ER  - /

# Find the year and title
s/(\([1-2][0-9][0-9][0-9]\)) *:* *\(.*@@N1\)/@@Y1  - \1@@T1  - \2/
s/@@A1  - \([1-2][0-9][0-9][0-9]\)[ ]*:[ ]*\(.*@@N1\)/@@Y1  - \1@@T1  - \2/
s/\(@@A1  - [^@"]*\)\"/\1@@T1  - /
s/@@T1  - [ "]*/@@T1  - /

# Find the second title then determine what it is...
s/\(@@T1  - [^@]*\)\"\(.*@@N1\)/\1@@T2  - \2/
s/: \([0-9][0-9]* *pp\.*\)/@@U1  - \1/
# Theses
#  Remove Canterbury before publication...
s/@@T2  - [^@]*Thesis for \([^@]*\) [Ii]n \([^@]*\)/@@CY  - Christchurch@@PB  - University of Canterbury, \2@@M2  - \1/
# Book chapters
s/@@T2  - [^@]*Ch\.* *\([0-9][0-9]*\)/@@CP  - \1@@T2  - /
s/@@T2  - [ :p,.]*\([0-9][0-9]*-[0-9][0-9]*\)/@@SP  - \1@@T2  - /

# Journals
s/@@T2  - \([^@]*\) \([0-9()][0-9()]*\): *\([-0-9][-0-9]*\)/@@JF  - \1@@VL  - \2@@SP  - \3/
s/\(@@VL  - [-0-9][-0-9A-Z]*\)(\([-0-9][-0-9]*\))/\1@@IS  - \2/

# Deal with book titles and editors
s/@@T2  - [. ]*in /@@T2  - /
s/\(@@T2  - [^@]*\) \([0-9][0-9]*..\) [Ee]d/\1@@VL  - \2/
s/ Eds*\.* /@@A2  - /

# Split authors appropriately
s/\(@@A2  - [^@]*\) and /\1@@A2  - /
: au_loop
s/\(@@A1  - [^@]*, [-A-Z. ][-A-Z. ]*\)[,;]/\1@@A1  - /
s/\(@@A2  - [^@]*\)[,;&]/\1@@A2  - /
s/\(@@A2  - [^@]*[a-z]\)\./\1@@PB  - /
t au_loop

# Reverse editors' names
s/@@A2  - \([A-Z. ]*\)\([A-Z][-a-zA-Z ]*\)/@@A2  - \2, \1/g

# Deal with publishers and non-publishers
s/\(@@PB  - [^@]*\)@@PB  - /\1@@CY  - /
s/\(@@PB  - [^@]*\)@@A2  - /\1@@CY  - /
: pb_loop
s/\(@@CY  - [^@]*\)@@PB  - /\1\. /
s/\(@@PB  - [^@]*\)@@A2  - /\1\. /
t pb_loop

# Tidy up
s/\(@@..  - \)[ .-]*/\1/g
s/\(@@..  - \)@@//g
s/\(@@..  - \)[^0-9a-zA-Z]/\1/g

# Classify records
/@@JF/s/^/@@TY  - JOUR/
/@@TY/!s/^\(.*@@UR\)/@@TY  - ELEC\1/
/@@TY/!s/^\(.*@@M2\)/@@TY  - THES\1/
/@@TY/!s/^\(.* [Uu]npublished\)/@@TY  - UNPB\1/
/@@TY/!s/^\(.* [Rr]eport\)/@@TY  - RPRT\1/
/@@TY/!s/^\(.* [Cc]onference\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Pp]roceedings\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Cc]ongress\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Ww]orkshop\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Ss]eminar\)/@@TY  - CONF\1/
/@@TY/!s/^\(.*@@T2\)/@@TY  - CHAP\1/
/@@TY/!s/^/@@TY  - BOOK/

# Finally replace placeholder with linebreak.
s/@@/\
/g