# Mystery Style #02 Ref2RIS Converter v. 1.0
# Copyright (C) 2011 Deborah Fitchett
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
########################################################################

# Tidy up tags, punctuation, spurious spacing, blank lines, and urls
s/\<[^/>]*\>$//
s/^\<\/[^>]*\>//
s/\(\<[^/>]*\>\)\([^0-9A-Za-z<>]*\)/\2\1/g
s/\([^0-9A-Za-z\<\>]*\)\(\<\/[^\>]*\>\)/\2\1/g
s/\<\([^>]*\)\>\<\/\1\>//g
s/\( \)*\([ ,.]\)/\2/g
s/[ 	][ 	]*/ /g
s/^[ ]*//
s/[ ]*$//
/^$/d
s/\([^/]\)www/\1http:\/\/www/g

# Deliminate records (adding a copy of the full record to the notes field)
s/\(.*\)$/@@A1  - \1@@N1  - \1@@ER  - /

# Strip numbers from the start
s/@@A1  - \W*[0-9][0-9]*\W*/@@A1  - /

# Find an url
s/\(http:[^ <>]*\)\(.*@@N1\)/@@UR  - \1@@XX  - \2/

# Find title
s/, \<i\>\(.*@@N1\)/@@T1  - \1/
s/\"\<i\>\(.*@@N1\)/@@T1  - \1/
s/\<\/i\>\(.*@@N1\)/@@XX  - \1/

# Find second title; editor; edited title
s/\" In \(.*@@N1\)/@@T2  - \1/
s/@@XX  - , ed\./@@A2  - /
s/\(@@T1  - [^@.]*\)\. \(.*@@N1\)/\1@@T2  - \2/

# Find year and publisher; city; pages
s/@@XX  - \. \([1-2][0-9][0-9][0-9]\), /@@Y1  - \1@@PB  - /
s/\(@@A2  - [^@0-9]*\)\. \([1-2][0-9][0-9][0-9]\)/\1@@Y1  - \2@@PB  - /
s/\(@@PB  - [^@:]*\): /\1@@CY  - /
s/\(@@CY  - [^@.]*\)\. p\. /\1@@SP  - /

# Find journal title; year and volume; issue; pages
s/@@XX  - /@@JF  - /
s/, \([1-2][0-9][0-9][0-9]\)\. \<b\>\(.*@@N1\)/@@Y1  - \1@@VL  - \2/
s/\<\/b\>(\(.*@@N1\)/@@IS  - \1/
s/\<\/b\>: p\. \(.*@@N1\)/@@SP  - \1/
s/): p\. \([a-zA-Z]*[0-9][0-9]*[- ]*[0-9][0-9]*\)\(.*@@N1\)/@@SP  - \1@@XX  - \2/

# Get rid of unnecessary html tags (bold, italics, underline)
s/\<\/*b\>//g
s/\<\/*i\>//g
s/\<\/*u\>//g

# Split authors and reorder I.N. Surname -> Surname, I.N.
s/\(@@A[^@]*\), et al\.*\(.*@@N1\)/\1\2/
s/\(@@A[1-2]  - \)\([^@]*\),* and \(.*@@N1\)/\1\2\1\3/
s/\(@@A[1-2]  - \)\([^@]*\)\., /\1\2\.\1/
s/\(@@A[1-2]  - \)\([A-Z]\.[.A-Z]*\) \([a-zA-Z]*\)/\1\3, \2/g

# Tidy stray spaces and punctuation
s/  - */  - /g
s/[(), ]*@@/@@/g
s/\(@@[^ANX][^@]*\)\.@/\1@/g
s/\(@@[^N].  - \)[^0-9a-zA-Z<@]*/\1/g
: tidy
s/@@..  - *@@/@@/
s/\(@@T1  - .*\)@@T1  - /\1@@T2  - /
s/\(@@T2  - .*\)@@T2  - /\1@@T3  - /
t tidy

# Classify records
/@@JF/s/^/@@TY  - JOUR/
/@@TY/!s/^\(.*@@UR\)/@@TY  - ELEC\1/
/@@TY/!s/^\(.* [Tt]hesis\)/@@TY  - THES\1/
/@@TY/!s/^\(.* [Dd]issertation\)/@@TY  - THES\1/
/@@TY/!s/^\(.* [Cc]onference\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Cc]ongress\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Ww]orkshop\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Ss]eminar\)/@@TY  - CONF\1/
/@@TY/!s/^\(.* [Rr]eport\)/@@TY  - RPRT\1/
/@@TY/!s/^\(.*@@T2\)/@@TY  - CHAP\1/
/@@TY/!s/^/@@TY  - BOOK/

# Finally replace placeholder with linebreak.
s/@@/\
/g